package uk.ac.ox.eolo;


import org.semanticweb.HermiT.model.AtomicRole;
import org.semanticweb.HermiT.model.Role;

import uk.ac.ox.cs.JRDFox.Prefixes;

public class URIUtils {

	
	public static String shorten(String iri) {
		iri = removeBrackets(iri);
		if (iri.contains("#")) {
			return iri.substring(iri.indexOf('#')+1);
		} else {
			return iri.substring(iri.indexOf(':')+1);
		}
	}
	
	
	public static String removeBrackets(String iri) {
		if (iri.contains("<"))
			iri =iri.replaceAll("<", "");
		if (iri.contains(">"))
			return iri.replaceAll(">", "");
		return iri;
	}
	
	
	public static String getFullURI(String iri, Prefixes pref) {
		 return pref.expandAbbreviatedIRI(removeBrackets(iri));
		 
		 
	}
	
	public static String getRole(Role p, Prefixes pref) {
		String p_string = URIUtils.removeBrackets(p.toString());
		if (pref.canBeExpanded(p_string))
			return pref.expandAbbreviatedIRI(p_string);
		return p_string;
	}

}
