package uk.ac.ox.eolo.combinatorics;

import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;

public class BalancedStringEnumerator {
	
	private static Map<Integer,Set<String>> memo = new HashMap<Integer,Set<String>>();
	private static boolean initialised =false;

	private static void memorise(int i, String s) {
		if (memo.containsKey(i)) {
			memo.get(i).add(s);
		} else {
			Set<String> set = new LinkedHashSet<String>();
			set.add(s);
			memo.put(i, set);
		}
	}
	
	
	private static Set<String> memoGet(int i) {
		if (memo.containsKey(i))
			return memo.get(i);
		return  generateBalancedStrings(i);	
	}
	
		
	/**
	 * 
	 * @param n the number of matching parenthesis
	 * @return a set containing all string containing exactly n matching parenthesis
	 */
	public static Set<String> generateBalancedStrings(int n) {
		if(!initialised) {
			memorise(0, "");
		}
		if (n == 0) {
			return memo.get(0);
		}
		for (int i = 0; i < n; i++) {
			for (String x : memoGet(i)) {
				for (String y : memoGet(n-1 -i)) {
					memorise(n, "(" + x + ")" +y);
				}
			}
		}
		return memo.get(n);
	}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
	
	
	public static void clear() {
		memo.clear();
	}
}
