package uk.ac.ox.eolo.combinatorics;

import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;

public class LabelledStringEnumerator {

	private  Map<Integer, Set<String>> memo;
	private Set<String> labels;
	
	
	public LabelledStringEnumerator(Set<String> labels) {
		memo = new HashMap<Integer,Set<String>>();
		memorise(0, "");
		
	}
	

	private void memorise(int n, String s) {
		if (memo.containsKey(n)) {
			memo.get(n).add(s);
		} else {
			Set<String> set = new LinkedHashSet<String>();
			set.add(s);
			memo.put(n, set);
		}
	}
	
	
	private boolean isValid(String s, Set<String> clabels) {
		for (String  l : labels) {
			if (s.contains("[" + l + "]") && !clabels.contains(l))
				return false;
		}
		return true;
	}
	
	private Set<String> memoGet(int i, Set<String> clabels) {
		Set<String> set = new LinkedHashSet<String>();
		if (memo.containsKey(i)) {
			for (String s : memo.get(i)) {
				if (isValid(s, clabels))
					set.add(s);
			}
			return set;
		}
		return  generateAllStrings(i,clabels);	
	}
	
	/**
	 * 
	 * @param n the number of matching parenthesis
	 * @return a set containing all string containing exactly n matching parenthesis
	 */
	public Set<String> generateAllStrings(int n, Set<String> clabels) {
		if (n == 0) {
			return memo.get(0);
		}
		for (int i = 0; i < n; i++) {
			for (String rLabel : clabels)                                                                                   
				for (String x : memoGet(i, clabels)) {
					for (String y : memoGet(n-1 -i, clabels)) {
						memorise(n, "(" + x + ")" +y);
					}
				}
		}
		return memo.get(n);
	}
	
	


}
