package uk.ac.ox.eolo.reasoner;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class Enumerator<T> implements Iterable<Map<T, T>> {
	
	private List<Pair<T, List<T>>> pairList;
	private Map<T, T> renaming;

	public Enumerator(List<Pair<T, List<T>>> list) {
		this.pairList = list;
		renaming = new HashMap<T, T>();
		for (Pair<T, List<T>> p: pairList) 
			renaming.put(p.getFirst(), p.getSecond().get(0));
	}
	
	public Map<T, T> getFirst() {
		return renaming;
	}

	@Override
	public Iterator<Map<T, T>> iterator() {
		// TODO Auto-generated method stub
		return new EnumeratorIterator();
	}
	
	
	public class EnumeratorIterator implements Iterator<Map<T, T>> {
		
		private int[] indexes;
		private boolean isFirst;
		
		public EnumeratorIterator(){
			isFirst=true;
			indexes = new int[pairList.size()];
			for (int i = 0; i<indexes.length; i++)  {
				indexes[i]= 0;
			}
		}

		@Override
		public boolean hasNext() {
			if(isFirst) {
				return true;
			} else {
			for (int i = 0; i < pairList.size(); i++) 
				if(indexes[i] < (pairList.get(i).getSecond().size()-1))
					return true;
			return false;
			}
		}

		@Override
		public Map<T, T> next() {
			if(isFirst) {
				isFirst=false;
				return renaming;
			} else {
			int m = indexes.length-1;
			while (indexes[m] == (pairList.get(m).getSecond().size()-1))
				m--;
			renaming.put(pairList.get(m).getFirst(), pairList.get(m).getSecond().get(indexes[m]+1));
			indexes[m] = indexes[m]+1;
			for (int i = m+1; i < indexes.length; i++) {
				indexes[i] = 0;
				renaming.put(pairList.get(i).getFirst(), pairList.get(i).getSecond().get(indexes[i]));
			}
			return renaming;
			}
		}

		@Override
		public void remove() {
			// TODO Auto-generated method stub
			
		}


	}

}
