package uk.ac.ox.eolo.reasoner;


public class ResultCollector {
	
	

	private  long validAnswers;
	private  long totalSpurious;
	private  long soundTime;
	private  long numberOfChoices;
	
	
	
	public ResultCollector() {
	}
	
	
	
	public synchronized void addSound() {
		validAnswers++;
	}
	
	
	public synchronized boolean isEmpty() {
		return (validAnswers==0);
	}
	
	public synchronized void addUnSound() {
			totalSpurious++;
	}
	
	public synchronized void addTime(long time) {
		soundTime +=time;
	}
	
	
	public synchronized double getTotalNumber() {
		return validAnswers+ totalSpurious; 
	}
	
	public synchronized  double getAvarageTime() {
		if (getTotalNumber() >0)
			return soundTime / getTotalNumber(); 
		return 0.0;
	}
	
	
	
	public synchronized double getAvarageChoises() {
		if (getTotalNumber() >0)
			return numberOfChoices / getTotalNumber(); 
		return 0.0;
	}
	
	
	public synchronized void setChoices(long c) {
		this.numberOfChoices =c;
	}
	


	public synchronized long getTotalSpurious() {
		return totalSpurious;
	}


	public synchronized long getSoundTime() {
		return soundTime;
	}


	

	public synchronized long getNumberOfChoices() {
		return numberOfChoices;
	}

	public synchronized  void increaseChoices() {
		numberOfChoices++;
	}
	
	public synchronized void increaseChoices(long i) {
		numberOfChoices +=i;
	}
	
	
	public String toString() {
		return "Total number of answers " + getTotalNumber() + "\n" +
				"Valid answers " + validAnswers + "\n"+
				"Spurious answers " + totalSpurious + "\n";
	}

	

}
